org.codehaus.groovy.tools.groovydoc

## Class SimpleGroovyClassDoc

- java.lang.Object
- - org.codehaus.groovy.tools.groovydoc.SimpleGroovyDoc
  - - org.codehaus.groovy.tools.groovydoc.SimpleGroovyProgramElementDoc
    - - org.codehaus.groovy.tools.groovydoc.SimpleGroovyAbstractableElementDoc
      - - org.codehaus.groovy.tools.groovydoc.SimpleGroovyClassDoc

All Implemented Interfaces:
  java.lang.Comparable, GroovyTokenTypes, GroovyClassDoc, GroovyDoc, GroovyProgramElementDoc, GroovyType

    public class SimpleGroovyClassDoc
    extends SimpleGroovyAbstractableElementDoc
    implements GroovyClassDoc

### Field Summary

Fields
`static java.util.regex.Pattern` `CODE_REGEX`
`static java.lang.String` `DOCROOT_PATTERN`
`static java.lang.String` `DOCROOT_PATTERN2`
`static java.util.regex.Pattern` `LINK_REGEX`
`static java.util.regex.Pattern` `LITERAL_REGEX`
`static java.util.regex.Pattern` `NAME_ARGS_REGEX`
`static java.util.regex.Pattern` `REF_LABEL_REGEX`
`static java.util.regex.Pattern` `SPLIT_ARGS_REGEX`
`static java.util.regex.Pattern` `TAG_REGEX`

### Fields inherited from interface org.codehaus.groovy.antlr.parser.GroovyTokenTypes

`ABSTRACT, ANNOTATION, ANNOTATION_ARRAY_INIT, ANNOTATION_DEF, ANNOTATION_FIELD_DEF, ANNOTATION_MEMBER_VALUE_PAIR, ANNOTATIONS, ARRAY_DECLARATOR, ASSIGN, AT, BAND, BAND_ASSIGN, BIG_SUFFIX, BLOCK, BNOT, BOR, BOR_ASSIGN, BSR, BSR_ASSIGN, BXOR, BXOR_ASSIGN, CASE_GROUP, CLASS_DEF, CLOSABLE_BLOCK, CLOSABLE_BLOCK_OP, CLOSURE_LIST, COLON, COMMA, COMPARE_TO, CTOR_CALL, CTOR_IDENT, DEC, DIGIT, DIGITS_WITH_UNDERSCORE, DIGITS_WITH_UNDERSCORE_OPT, DIV, DIV_ASSIGN, DOLLAR, DOLLAR_REGEXP_CTOR_END, DOLLAR_REGEXP_LITERAL, DOLLAR_REGEXP_SYMBOL, DOT, DYNAMIC_MEMBER, ELIST, ELVIS_OPERATOR, EMPTY_STAT, ENUM_CONSTANT_DEF, ENUM_DEF, EOF, EQUAL, ESC, ESCAPED_DOLLAR, ESCAPED_SLASH, EXPONENT, EXPR, EXTENDS_CLAUSE, FINAL, FLOAT_SUFFIX, FOR_CONDITION, FOR_EACH_CLAUSE, FOR_IN_ITERABLE, FOR_INIT, FOR_ITERATOR, GE, GT, HEX_DIGIT, IDENT, IDENTICAL, IMPLEMENTS_CLAUSE, IMPLICIT_PARAMETERS, IMPORT, INC, INDEX_OP, INSTANCE_INIT, INTERFACE_DEF, LABELED_ARG, LABELED_STAT, LAND, LBRACK, LCURLY, LE, LETTER, LIST_CONSTRUCTOR, LITERAL_as, LITERAL_assert, LITERAL_boolean, LITERAL_break, LITERAL_byte, LITERAL_case, LITERAL_catch, LITERAL_char, LITERAL_class, LITERAL_continue, LITERAL_def, LITERAL_default, LITERAL_double, LITERAL_else, LITERAL_enum, LITERAL_extends, LITERAL_false, LITERAL_finally, LITERAL_float, LITERAL_for, LITERAL_if, LITERAL_implements, LITERAL_import, LITERAL_in, LITERAL_instanceof, LITERAL_int, LITERAL_interface, LITERAL_long, LITERAL_native, LITERAL_new, LITERAL_null, LITERAL_package, LITERAL_private, LITERAL_protected, LITERAL_public, LITERAL_return, LITERAL_short, LITERAL_static, LITERAL_super, LITERAL_switch, LITERAL_synchronized, LITERAL_this, LITERAL_threadsafe, LITERAL_throw, LITERAL_throws, LITERAL_trait, LITERAL_transient, LITERAL_true, LITERAL_try, LITERAL_void, LITERAL_volatile, LITERAL_while, LNOT, LOR, LPAREN, LT, MAP_CONSTRUCTOR, MEMBER_POINTER, METHOD_CALL, METHOD_DEF, MINUS, MINUS_ASSIGN, ML_COMMENT, MOD, MOD_ASSIGN, MODIFIERS, MULTICATCH, MULTICATCH_TYPES, NLS, NOT_EQUAL, NOT_IDENTICAL, NULL_TREE_LOOKAHEAD, NUM_BIG_DECIMAL, NUM_BIG_INT, NUM_DOUBLE, NUM_FLOAT, NUM_INT, NUM_LONG, OBJBLOCK, ONE_NL, OPTIONAL_DOT, PACKAGE_DEF, PARAMETER_DEF, PARAMETERS, PLUS, PLUS_ASSIGN, POST_DEC, POST_INC, QUESTION, RANGE_EXCLUSIVE, RANGE_INCLUSIVE, RBRACK, RCURLY, REGEX_FIND, REGEX_MATCH, REGEXP_CTOR_END, REGEXP_LITERAL, REGEXP_SYMBOL, RPAREN, SELECT_SLOT, SEMI, SH_COMMENT, SL, SL_ASSIGN, SL_COMMENT, SLIST, SPREAD_ARG, SPREAD_DOT, SPREAD_MAP_ARG, SR, SR_ASSIGN, STAR, STAR_ASSIGN, STAR_STAR, STAR_STAR_ASSIGN, STATIC_IMPORT, STATIC_INIT, STRICTFP, STRING_CH, STRING_CONSTRUCTOR, STRING_CTOR_END, STRING_CTOR_MIDDLE, STRING_CTOR_START, STRING_LITERAL, STRING_NL, SUPER_CTOR_CALL, TRAIT_DEF, TRIPLE_DOT, TYPE, TYPE_ARGUMENT, TYPE_ARGUMENTS, TYPE_LOWER_BOUNDS, TYPE_PARAMETER, TYPE_PARAMETERS, TYPE_UPPER_BOUNDS, TYPECAST, UNARY_MINUS, UNARY_PLUS, UNUSED_CONST, UNUSED_DO, UNUSED_GOTO, VARIABLE_DEF, VARIABLE_PARAMETER_DEF, VOCAB, WILDCARD_TYPE, WS`

### Constructor Summary

Constructors
Constructor and Description
`SimpleGroovyClassDoc(java.util.List<java.lang.String> importedClassesAndPackages, java.util.Map<java.lang.String,java.lang.String> aliases, java.lang.String name)`
`SimpleGroovyClassDoc(java.util.List<java.lang.String> importedClassesAndPackages, java.util.Map<java.lang.String,java.lang.String> aliases, java.lang.String name, java.util.List<LinkArgument> links)`
`SimpleGroovyClassDoc(java.util.List<java.lang.String> importedClassesAndPackages, java.lang.String name)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`boolean` `add(GroovyConstructorDoc constructor)`
`boolean` `add(GroovyFieldDoc field)`
`boolean` `add(GroovyMethodDoc method)`
`boolean` `addEnumConstant(GroovyFieldDoc field)`
`void` `addInterfaceName(java.lang.String className)`
`boolean` `addNested(GroovyClassDoc nestedClass)`
`boolean` `addProperty(GroovyFieldDoc property)`
`java.lang.String` `commentText()`
`GroovyConstructorDoc[]` `constructors()` returns a sorted array of constructors
`GroovyConstructorDoc[]` `constructors(boolean filter)`
`static java.lang.String` `decodeSpecialSymbols(java.lang.String text)`
`boolean` `definesSerializableFields()`
`static java.lang.String` `encodeAngleBrackets(java.lang.String text)`
`static java.lang.String` `encodeAngleBracketsInTagBody(java.lang.String text, java.util.regex.Pattern regex)` Replaces angle brackets inside a tag.
`static java.lang.String` `encodeSpecialSymbols(java.lang.String text)`
`GroovyFieldDoc[]` `enumConstants()` returns a sorted array of enum constants
`GroovyFieldDoc[]` `fields()` returns a sorted array of fields
`GroovyFieldDoc[]` `fields(boolean filter)`
`GroovyClassDoc` `findClass(java.lang.String className)`
`java.lang.String` `firstSentenceCommentText()`
`java.lang.String` `getDocUrl(java.lang.String type)`
`java.lang.String` `getDocUrl(java.lang.String type, boolean full)`
`static java.lang.String` `getDocUrl(java.lang.String type, boolean full, java.util.List<LinkArgument> links, java.lang.String relativePath, GroovyRootDoc rootDoc, SimpleGroovyClassDoc classDoc)`
`java.lang.String` `getFullPathName()`
`java.lang.String` `getNameWithTypeArgs()`
`GroovyClassDoc` `getOuter()`
`java.util.List<GroovyClassDoc>` `getParentClasses()`
`java.util.Set<GroovyClassDoc>` `getParentInterfaces()`
`java.lang.String` `getRelativeRootPath()`
`java.lang.String` `getSuperClassName()`
`GroovyClassDoc[]` `importedClasses()`
`GroovyPackageDoc[]` `importedPackages()`
`GroovyClassDoc[]` `innerClasses()` returns a sorted array of nested classes and interfaces
`GroovyClassDoc[]` `innerClasses(boolean filter)`
`GroovyClassDoc[]` `interfaces()`
`GroovyType[]` `interfaceTypes()`
`boolean` `isExternalizable()`
`boolean` `isGroovy()`
`boolean` `isPrimitive()`
`boolean` `isSerializable()`
`GroovyMethodDoc[]` `methods()` returns a sorted array of methods
`GroovyMethodDoc[]` `methods(boolean filter)`
`GroovyFieldDoc[]` `properties()` returns a sorted array of properties
`java.lang.String` `qualifiedTypeName()` The qualified name of this type excluding any dimension information.
`java.lang.String` `replaceAllTags(java.lang.String self, java.lang.String s1, java.lang.String s2, java.util.regex.Pattern regex)`
`static java.lang.String` `replaceAllTags(java.lang.String self, java.lang.String s1, java.lang.String s2, java.util.regex.Pattern regex, java.util.List<LinkArgument> links, java.lang.String relPath, GroovyRootDoc rootDoc, SimpleGroovyClassDoc classDoc)`
`java.lang.String` `replaceAllTagsCollated(java.lang.String self, java.lang.String preKey, java.lang.String postKey, java.lang.String valueSeparator, java.lang.String postValues, java.util.regex.Pattern regex)`
`java.lang.String` `replaceTags(java.lang.String comment)`
`GroovyFieldDoc[]` `serializableFields()`
`GroovyMethodDoc[]` `serializationMethods()`
`void` `setFullPathName(java.lang.String fullPathName)`
`void` `setGroovy(boolean isgroovy)`
`void` `setNameWithTypeArgs(java.lang.String nameWithTypeArgs)`
`void` `setOuter(GroovyClassDoc outer)`
`void` `setSuperClass(GroovyClassDoc doc)`
`void` `setSuperClassName(java.lang.String className)`
`java.lang.String` `simpleTypeName()` The unqualified name of this type excluding any dimension or nesting information.
`boolean` `subclassOf(GroovyClassDoc gcd)`
`GroovyClassDoc` `superclass()`
`GroovyType` `superclassType()`
`java.lang.String` `typeName()` The unqualified name of this type excluding any dimension information.

### Methods inherited from class org.codehaus.groovy.tools.groovydoc.SimpleGroovyAbstractableElementDoc

`isAbstract, setAbstract`

### Methods inherited from class org.codehaus.groovy.tools.groovydoc.SimpleGroovyProgramElementDoc

`addAnnotationRef, annotations, containingClass, containingPackage, isFinal, isPackagePrivate, isPrivate, isProtected, isPublic, isStatic, modifiers, modifierSpecifier, qualifiedName, setContainingPackage, setFinal, setPackagePrivate, setPrivate, setProtected, setPublic, setStatic`

### Methods inherited from class org.codehaus.groovy.tools.groovydoc.SimpleGroovyDoc

`calculateFirstSentence, compareTo, getRawCommentText, getTypeDescription, getTypeSourceDescription, isAnnotationType, isAnnotationTypeElement, isClass, isConstructor, isDeprecated, isEnum, isEnumConstant, isError, isException, isField, isIncluded, isInterface, isMethod, isOrdinaryClass, isScript, isTrait, name, setCommentText, setDeprecated, setFirstSentenceCommentText, setRawCommentText, setScript, setTokenType, tags, tokenType, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyClassDoc

`isAbstract`

### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyType

`toString`

### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyProgramElementDoc

`annotations, containingClass, containingPackage, isFinal, isPackagePrivate, isPrivate, isProtected, isPublic, isStatic, modifiers, modifierSpecifier, qualifiedName`

### Methods inherited from interface org.codehaus.groovy.groovydoc.GroovyDoc

`getRawCommentText, isAnnotationType, isAnnotationTypeElement, isClass, isConstructor, isDeprecated, isEnum, isEnumConstant, isError, isException, isField, isIncluded, isInterface, isMethod, isOrdinaryClass, name, setRawCommentText`

### Methods inherited from interface java.lang.Comparable

`compareTo`

### Field Detail

#### TAG_REGEX

    public static final java.util.regex.Pattern TAG_REGEX

#### DOCROOT_PATTERN2

    public static final java.lang.String DOCROOT_PATTERN2

See Also:
  Constant Field Values

#### DOCROOT_PATTERN

    public static final java.lang.String DOCROOT_PATTERN

See Also:
  Constant Field Values

#### LINK_REGEX

    public static final java.util.regex.Pattern LINK_REGEX

#### LITERAL_REGEX

    public static final java.util.regex.Pattern LITERAL_REGEX

#### CODE_REGEX

    public static final java.util.regex.Pattern CODE_REGEX

#### REF_LABEL_REGEX

    public static final java.util.regex.Pattern REF_LABEL_REGEX

#### NAME_ARGS_REGEX

    public static final java.util.regex.Pattern NAME_ARGS_REGEX

#### SPLIT_ARGS_REGEX

    public static final java.util.regex.Pattern SPLIT_ARGS_REGEX

### Constructor Detail

#### SimpleGroovyClassDoc

    public SimpleGroovyClassDoc(java.util.List<java.lang.String> importedClassesAndPackages,
                                java.util.Map<java.lang.String,java.lang.String> aliases,
                                java.lang.String name,
                                java.util.List<LinkArgument> links)

#### SimpleGroovyClassDoc

    public SimpleGroovyClassDoc(java.util.List<java.lang.String> importedClassesAndPackages,
                                java.util.Map<java.lang.String,java.lang.String> aliases,
                                java.lang.String name)

#### SimpleGroovyClassDoc

    public SimpleGroovyClassDoc(java.util.List<java.lang.String> importedClassesAndPackages,
                                java.lang.String name)

### Method Detail

#### constructors

    public GroovyConstructorDoc[] constructors()

returns a sorted array of constructors

Specified by:
  `constructors` in interface `GroovyClassDoc`

#### add

    public boolean add(GroovyConstructorDoc constructor)

#### getOuter

    public GroovyClassDoc getOuter()

#### setOuter

    public void setOuter(GroovyClassDoc outer)

#### isGroovy

    public boolean isGroovy()

#### setGroovy

    public void setGroovy(boolean isgroovy)

#### innerClasses

    public GroovyClassDoc[] innerClasses()

returns a sorted array of nested classes and interfaces

Specified by:
  `innerClasses` in interface `GroovyClassDoc`

#### addNested

    public boolean addNested(GroovyClassDoc nestedClass)

#### fields

    public GroovyFieldDoc[] fields()

returns a sorted array of fields

Specified by:
  `fields` in interface `GroovyClassDoc`

#### add

    public boolean add(GroovyFieldDoc field)

#### properties

    public GroovyFieldDoc[] properties()

returns a sorted array of properties

Specified by:
  `properties` in interface `GroovyClassDoc`

#### addProperty

    public boolean addProperty(GroovyFieldDoc property)

#### enumConstants

    public GroovyFieldDoc[] enumConstants()

returns a sorted array of enum constants

Specified by:
  `enumConstants` in interface `GroovyClassDoc`

#### addEnumConstant

    public boolean addEnumConstant(GroovyFieldDoc field)

#### methods

    public GroovyMethodDoc[] methods()

returns a sorted array of methods

Specified by:
  `methods` in interface `GroovyClassDoc`

#### add

    public boolean add(GroovyMethodDoc method)

#### getSuperClassName

    public java.lang.String getSuperClassName()

#### setSuperClassName

    public void setSuperClassName(java.lang.String className)

#### superclass

    public GroovyClassDoc superclass()

Specified by:
  `superclass` in interface `GroovyClassDoc`

#### setSuperClass

    public void setSuperClass(GroovyClassDoc doc)

#### getFullPathName

    public java.lang.String getFullPathName()

Specified by:
  `getFullPathName` in interface `GroovyClassDoc`

#### setFullPathName

    public void setFullPathName(java.lang.String fullPathName)

#### getRelativeRootPath

    public java.lang.String getRelativeRootPath()

Specified by:
  `getRelativeRootPath` in interface `GroovyClassDoc`

#### getParentClasses

    public java.util.List<GroovyClassDoc> getParentClasses()

#### getParentInterfaces

    public java.util.Set<GroovyClassDoc> getParentInterfaces()

#### getDocUrl

    public java.lang.String getDocUrl(java.lang.String type)

#### getDocUrl

    public java.lang.String getDocUrl(java.lang.String type,
                                      boolean full)

#### getDocUrl

    public static java.lang.String getDocUrl(java.lang.String type,
                                             boolean full,
                                             java.util.List<LinkArgument> links,
                                             java.lang.String relativePath,
                                             GroovyRootDoc rootDoc,
                                             SimpleGroovyClassDoc classDoc)

#### constructors

    public GroovyConstructorDoc[] constructors(boolean filter)

Specified by:
  `constructors` in interface `GroovyClassDoc`

#### definesSerializableFields

    public boolean definesSerializableFields()

Specified by:
  `definesSerializableFields` in interface `GroovyClassDoc`

#### fields

    public GroovyFieldDoc[] fields(boolean filter)

Specified by:
  `fields` in interface `GroovyClassDoc`

#### findClass

    public GroovyClassDoc findClass(java.lang.String className)

Specified by:
  `findClass` in interface `GroovyClassDoc`

#### importedClasses

    public GroovyClassDoc[] importedClasses()

Specified by:
  `importedClasses` in interface `GroovyClassDoc`

#### importedPackages

    public GroovyPackageDoc[] importedPackages()

Specified by:
  `importedPackages` in interface `GroovyClassDoc`

#### innerClasses

    public GroovyClassDoc[] innerClasses(boolean filter)

Specified by:
  `innerClasses` in interface `GroovyClassDoc`

#### interfaces

    public GroovyClassDoc[] interfaces()

Specified by:
  `interfaces` in interface `GroovyClassDoc`

#### interfaceTypes

    public GroovyType[] interfaceTypes()

Specified by:
  `interfaceTypes` in interface `GroovyClassDoc`

#### isExternalizable

    public boolean isExternalizable()

Specified by:
  `isExternalizable` in interface `GroovyClassDoc`

#### isSerializable

    public boolean isSerializable()

Specified by:
  `isSerializable` in interface `GroovyClassDoc`

#### methods

    public GroovyMethodDoc[] methods(boolean filter)

Specified by:
  `methods` in interface `GroovyClassDoc`

#### serializableFields

    public GroovyFieldDoc[] serializableFields()

Specified by:
  `serializableFields` in interface `GroovyClassDoc`

#### serializationMethods

    public GroovyMethodDoc[] serializationMethods()

Specified by:
  `serializationMethods` in interface `GroovyClassDoc`

#### subclassOf

    public boolean subclassOf(GroovyClassDoc gcd)

Specified by:
  `subclassOf` in interface `GroovyClassDoc`

#### superclassType

    public GroovyType superclassType()

Specified by:
  `superclassType` in interface `GroovyClassDoc`

#### isPrimitive

    public boolean isPrimitive()

Specified by:
  `isPrimitive` in interface `GroovyType`

#### qualifiedTypeName

    public java.lang.String qualifiedTypeName()

Description copied from interface: `GroovyType`
The qualified name of this type excluding any dimension information. For example, a two dimensional array of String returns "`java.lang.String`".

Specified by:
  `qualifiedTypeName` in interface `GroovyType`

#### simpleTypeName

    public java.lang.String simpleTypeName()

Description copied from interface: `GroovyType`
The unqualified name of this type excluding any dimension or nesting information. For example, the class `Outer.Inner` returns "`Inner`".

Specified by:
  `simpleTypeName` in interface `GroovyType`

#### typeName

    public java.lang.String typeName()

Description copied from interface: `GroovyType`
The unqualified name of this type excluding any dimension information. For example, a two dimensional array of String returns "`String`".

Specified by:
  `typeName` in interface `GroovyType`

#### addInterfaceName

    public void addInterfaceName(java.lang.String className)

#### firstSentenceCommentText

    public java.lang.String firstSentenceCommentText()

Specified by:
  `firstSentenceCommentText` in interface `GroovyDoc`
Overrides:
  `firstSentenceCommentText` in class `SimpleGroovyDoc`

#### commentText

    public java.lang.String commentText()

Specified by:
  `commentText` in interface `GroovyDoc`
Overrides:
  `commentText` in class `SimpleGroovyDoc`

#### replaceTags

    public java.lang.String replaceTags(java.lang.String comment)

#### replaceAllTags

    public java.lang.String replaceAllTags(java.lang.String self,
                                           java.lang.String s1,
                                           java.lang.String s2,
                                           java.util.regex.Pattern regex)

#### replaceAllTags

    public static java.lang.String replaceAllTags(java.lang.String self,
                                                  java.lang.String s1,
                                                  java.lang.String s2,
                                                  java.util.regex.Pattern regex,
                                                  java.util.List<LinkArgument> links,
                                                  java.lang.String relPath,
                                                  GroovyRootDoc rootDoc,
                                                  SimpleGroovyClassDoc classDoc)

#### replaceAllTagsCollated

    public java.lang.String replaceAllTagsCollated(java.lang.String self,
                                                   java.lang.String preKey,
                                                   java.lang.String postKey,
                                                   java.lang.String valueSeparator,
                                                   java.lang.String postValues,
                                                   java.util.regex.Pattern regex)

#### encodeAngleBracketsInTagBody

    public static java.lang.String encodeAngleBracketsInTagBody(java.lang.String text,
                                                                java.util.regex.Pattern regex)

Replaces angle brackets inside a tag.

Parameters:
  `text` - GroovyDoc text to process
  `regex` - has to capture tag name in group 1 and tag body in group 2

#### encodeAngleBrackets

    public static java.lang.String encodeAngleBrackets(java.lang.String text)

#### encodeSpecialSymbols

    public static java.lang.String encodeSpecialSymbols(java.lang.String text)

#### decodeSpecialSymbols

    public static java.lang.String decodeSpecialSymbols(java.lang.String text)

#### setNameWithTypeArgs

    public void setNameWithTypeArgs(java.lang.String nameWithTypeArgs)

#### getNameWithTypeArgs

    public java.lang.String getNameWithTypeArgs()